//Bal - Dragos Oprica
//Complexitate - O (N^N) - 20
#include <algorithm>
#include <fstream>
#include <iomanip>
using namespace std;

ifstream fin ("bal.in");
ofstream fout ("bal.out");

#define DIM 255

double P[DIM][DIM];
double ret;
int f[DIM];
int N,K;

void read () {
  int i,j,x;

  fin>>N>>K;
  for (i=1; i<=N; ++i)
    for (j=1; j<=N; ++j) {

      fin>>x;
      P[i][j]=(double)x/100;
    }
}

void bulaneala () {
  double cur;
  int i,j;

  ret=1.0;
  for (j=1; j<=N; ++j) {

    cur=0.0;
    for (i=1; i<=N; ++i)
      cur=max (cur,P[i][j]);
    ret*=cur;
  }

  fout<<fixed<<setprecision (6)<<ret*100;
}

void back (int pas,double cur) {
  int i;

  if (pas==N+1)
    ret=max (ret,cur);
  else
    for (i=1; i<=N; ++i)
      if (f[i]<K) {

        ++f[i];
        back (pas+1,cur*P[i][pas]);
        --f[i];
      }
}

void solve () {

  back (1,1.0);
  fout<<fixed<<setprecision (6)<<ret*100;
}

int main () {

  read ();
  if (K==N)
    bulaneala ();
  else
    solve ();

  return 0;
}
