//Complexitate O (N * logN)

#define TuTTy "Cosmin-Mihai Tutunaru"
#include<cstdio>
#include<vector>
#include<stack>
#include<map>
#include<algorithm>
#define infile "triaj.in"
#define outfile "triaj.out"
#define mMax 1011

using namespace std;

struct move {
  int line, head;
  vector < pair<int, int> > v;
  move(int l, int h) {
    line = l, head = h;
  }
};

map <int, int> hash;
stack <int> le[mMax + 1];
stack <int> ri[mMax + 1];
vector <int> v, w;
vector <move> sol;
int n;

void read() {

  int x;
  scanf("%d\n", &n);

  for(int i = 1; i <= n; ++i) {
    scanf("%d", &x);
    v.push_back(x);
  }

}

void init() {

  w = v;

  sort(w.begin(), w.end());
  w.resize(unique(w.begin(), w.end()) - w.begin());

  for(unsigned i = 0; i < w.size(); ++i) {
    hash[w[i]] = i;
  }

  for(unsigned i = 0; i < v.size(); ++i) {
    v[i] = hash[v[i]];
  }

}

void solve() {

  for(unsigned i = 0; i < v.size(); ++i) {
    ri[0].push(v[i]);
  }


  move firstMove(0, 1);
  while(!ri[0].empty()) {
    firstMove.v.push_back(make_pair((ri[0].top() % mMax) + 1, 1));
    ri[(ri[0].top() % mMax) + 1].push(ri[0].top());
    ri[0].pop();
  }
  sol.push_back(firstMove);


  for(int i = 1; i <= mMax; ++i) {

    move crtMove(i, 1);
    while(!ri[i].empty()) {
      crtMove.v.push_back(make_pair(ri[i].top() / mMax + 1, 0));
      le[ri[i].top() / mMax + 1].push(ri[i].top());
      ri[i].pop();
    }

    if(!crtMove.v.empty()) {
      sol.push_back(crtMove);
    }

  }


  for(int i = mMax; i > 0; --i) {
    
    move crtMove(i, 0);
    while(!le[i].empty()) {
      crtMove.v.push_back(make_pair(0, 0));
      le[0].push(le[i].top());
      le[i].pop();
    }

    if(!crtMove.v.empty()) {
      sol.push_back(crtMove);
    }

  }

}

void write() {

  printf("%d\n", sol.size());
  for(unsigned i = 0; i < sol.size(); ++i) {
    printf("%d %d %d ", sol[i].line + 1, sol[i].head, sol[i].v.size());
    for(unsigned j = 0; j < sol[i].v.size(); ++j) {
      printf("%d %d ", sol[i].v[j].first + 1, sol[i].v[j].second);
    }
    printf("\n");
  }

}

int main() {
  freopen(infile, "r", stdin);
  freopen(outfile, "w", stdout);

  read();
  init();
  solve();
  write();

  fclose(stdin);
  fclose(stdout);
  return 0;
}
