#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<string>
#include<vector>
#include<queue>
#include<set>
#include<algorithm>
#define infile "triaj.in"
#define tmax 100

using namespace std;

struct test
{
  int n, v; //edges
} t[tmax];
int nr; //tests number

inline int randomValue(int a, int b)
{
  return (rand()%(b-a+1)) + a;
}

string makeString(int x)
{
  if(!x) return "0";
  string str;
  while(x)
    str = char((x%10) + '0') + str, x /= 10;
  return str;
}

void init()
{
  nr=20;
  t[1].n=13131;       t[1].v=1<<5;
  t[2].n=31313;       t[2].v=1<<7;
  t[3].n=66613;       t[3].v=1<<10;
  t[4].n=1313;        t[4].v=1<<11;
  t[5].n=1850;        t[5].v=1<<12;
  t[6].n=1999;        t[6].v=1<<13;
  t[7].n=2000;        t[7].v=1<<14;
  t[8].n=10*1313;     t[8].v=1<<15;
  t[9].n=50*1313;     t[9].v=1<<16;
  t[10].n=69*1313;    t[10].v=1<<17;
  t[11].n=333*1313;   t[11].v=1<<17;
  t[12].n=444*1313;   t[12].v=1<<18;
  t[13].n=555*1313;   t[13].v=1<<18;
  t[14].n=613*1313;   t[14].v=1<<19;
  t[15].n=650*1313;   t[15].v=1<<19;
  t[16].n=666*1313;   t[16].v=1<<26;
  t[17].n=700*1313;   t[17].v=1<<27;
  t[18].n=713*1313;   t[18].v=1<<28;
  t[19].n=731*1313;   t[19].v=1<<29;
  t[20].n=759*1313;   t[20].v=1<<30;
}

void addValues(vector <int> &v, int le, int ri, int sign, int st, int n) {

  for(int i = 0; i < n; ++i) {
    v[st + i] = le;
    if(le != ri) le += sign;
  }

}

void generate(struct test t, int nr)
{ //generate test number nr
  string file = makeString(nr) + "-" + infile;
  freopen(file.c_str(), "w", stdout);


  vector <int> v;
  int n = t.n;
  int vMax = t.v;
  int len = n / 13;


  for(int i = 1; i <= n; ++i) {
    v.push_back(randomValue(0, vMax));
  }

  for(int i = 0; i < 3; ++i) {
    addValues(v, max(0, vMax - randomValue(0, vMax/2)), vMax, 1, randomValue(0, v.size() - len - 1), len);
  }

  for(int i = 0; i < 3; ++i) {
    addValues(v, min(vMax, 0 + randomValue(0, vMax/2)), 0, -1, randomValue(0, v.size() - len - 1), len);
  }

  for(int i = 0; i < len / 2; ++i) {
    v[randomValue(0, v.size() - 1)] = randomValue(0, vMax);
  }

  printf("%d\n", v.size());
  for(unsigned i = 0; i < v.size(); ++i) {
    printf("%d ", v[i]);
  }


  fclose(stdout);
}

int main()
{
  srand((unsigned)time(0));
  init();

  for(int i = 1; i <= nr; ++i)
    generate(t[i],i);

  return 0;
}
